<?
/******************************/
/* VARIABLES DE CONFIGURATION */
/******************************/
$imgDir = stripslashes("./tomerge/");
$imgDestDir = stripslashes("./merged/");
$w = 1680;
$h = 1050;
$quality = 100;
$zoom = false;
$frame = true;
$mode = "";
/******************************/

$now = explode(' ',microtime());
$start = $now[0] + $now[1];

if(!is_dir($imgDir)) {
	echo("Erreur fatale : rpertoire source non valide !<br>");
}
else if(!is_dir($imgDestDir)) {
	echo("Erreur fatale : rpertoire de destination non valide !<br>");
}
else {
	$count = 0;
	$dirListing = opendir($imgDir);
	while ($file = readdir($dirListing)) {
		if($file != "." && $file != ".." && eregi(".jpg$",$file)) {
			$imgList[$count] = $file;
			$count++;
		}
	}
	closedir($dirListing);

	if($count > 1) {
        echo("Dbut du traitement de $count images.<br>");
        $j = 1;
        for($i = 0; $i < $count; $i++) {
            $now = explode(' ',microtime());
            $start1 = $now[0] + $now[1];
			$imgFile1 = $imgDir.$imgList[$i];
            if ($mode = "half") {
                $imgFileName2 = $imgList[($i + floor($count / 2)) % $count];
            }
            else if ($mode = "slide") {
    			$imgFileName2 = $imgList[($i + 1) % $count];
            }
            else {
    			$imgFileName2 = $imgList[($i + 1) % $count];
                $i++;
            }
    		$imgFile2 = $imgDir.$imgFileName2;
            if ($j < 10) {
                $mergeFileName = "00".$j.".jpg";
            }
            else if ($j < 100) {
                $mergeFileName = "0".$j.".jpg";
            }
            else {
                $mergeFileName = $j.".jpg";
            }
            $mergeFile = $imgDestDir.$mergeFileName;
            $j++;
            echo("Fusion de ".$imgList[$i]." et ".$imgFileName2." en ".$mergeFileName);
			if (createMerge($imgFile1, $imgFile2, $mergeFile)) {
                echo(" russie");
            }
            else {
                echo(" rate");
            }
            $now = explode(' ',microtime());
            $end1 = $now[0] + $now[1];
            echo(" (".($end1 - $start1).").<br>");
            flush();
		}
	}
}

$now = explode(' ',microtime());
$end = $now[0] + $now[1];
echo("Temps total de traitement : ".($end - $start));

function borderColor($img, $border = "top") {
    $x = imagesx($img);
    $y = imagesy($img);
    $color["R"] = 0;
    $color["G"] = 0;
    $color["B"] = 0;
    if ($border == "top" || $border == "bottom") {
        if ($border == "top") {
            $iy = 0;
        }
        else {
            $iy = $y - 1;
        }
        for ($ix = 0; $ix < $x; $ix++) {
            $pixColor = imagecolorat($img, $ix, $iy);
            $color["R"] += ($pixColor >> 16) & 0xFF;
            $color["G"] += ($pixColor >> 8) & 0xFF;
            $color["B"] += $pixColor & 0xFF;
        }
        $color["R"] = round($color["R"]/$x);
        $color["G"] = round($color["G"]/$x);
        $color["B"] = round($color["B"]/$x);
    }
    else if ($border == "left" || $border == "right") {
        if ($border == "left") {
            $ix = 0;
        }
        else {
            $ix = $x - 1;
        }
        for ($iy = 0; $iy < $y; $iy++) {
            $pixColor = imagecolorat($img, $ix, $iy);
            $color["R"] += ($pixColor >> 16) & 0xFF;
            $color["G"] += ($pixColor >> 8) & 0xFF;
            $color["B"] += $pixColor & 0xFF;
        }
        $color["R"] = round($color["R"]/$y);
        $color["G"] = round($color["G"]/$y);
        $color["B"] = round($color["B"]/$y);
    }
    return $color;
}

function imageCreateMargin($img) {
    global $w, $h, $zoom, $frame;
  	$x = imagesx($img);
	$y = imagesy($img);
    if ($x > $w || $y > $h) {
        $ratio = $x / $y;
        if ($ratio > $w / $h) {
            $tmp = imagecreatetruecolor($w, $w / $ratio);
            imagecopyresampled($tmp, $img, 0, 0, 0, 0, $w, $w / $ratio, $x, $y);
        }
        else {
            $tmp = imagecreatetruecolor($h * $ratio, $h);
            imagecopyresampled($tmp, $img, 0, 0, 0, 0, $h * $ratio, $h, $x, $y);
        }
        $img = $tmp;
  	    $x = imagesx($img);
    	$y = imagesy($img);
    }
    else if ($x < $w && $y < $h && $zoom) {
        $ratio = $x / $y;
        if ($ratio > $w / $h) {
            $tmp = imagecreatetruecolor($w, $w / $ratio);
            imagecopyresampled($tmp, $img, 0, 0, 0, 0, $w, $w / $ratio, $x, $y);
        }
        else {
            $tmp = imagecreatetruecolor($h * $ratio, $h);
            imagecopyresampled($tmp, $img, 0, 0, 0, 0, $h * $ratio, $h, $x, $y);
        }
        $img = $tmp;
  	    $x = imagesx($img);
    	$y = imagesy($img);
    }
    $wMargin = $w - $x;
    $hMargin = $h - $y;
    $res = imagecreatetruecolor($w, $h);
    if ($wMargin > 0) {
        $leftColor = borderColor($img, "left");
        $fillColor = imagecolorallocate($res, $leftColor["R"], $leftColor["G"], $leftColor["B"]);
        imagefilledrectangle($res, 0, 0, floor($wMargin / 2), $h - 1, $fillColor);
        $rightColor = borderColor($img, "right");
        $fillColor = imagecolorallocate($res, $rightColor["R"], $rightColor["G"], $rightColor["B"]);
        imagefilledrectangle($res, $w - 1 - $wMargin + floor($wMargin / 2), 0, $w - 1, $h - 1, $fillColor);
    }
    if ($hMargin > 0) {
        $topColor = borderColor($img, "top");
        $fillColor = imagecolorallocate($res, $topColor["R"], $topColor["G"], $topColor["B"]);
        imagefilledrectangle($res, 0, 0, $w - 1, floor($hMargin / 2), $fillColor);
        $bottomColor = borderColor($img, "bottom");
        $fillColor = imagecolorallocate($res, $bottomColor["R"], $bottomColor["G"], $bottomColor["B"]);
        imagefilledrectangle($res, 0,  $h - 1 - $hMargin + floor($hMargin / 2), $w - 1, $h - 1, $fillColor);
    }
    if ($wMargin > 0 && $hMargin > 0 && $frame) {
        $frameColor["R"] = round(($leftColor["R"] + $rightColor["R"] + $topColor["R"] + $bottomColor["R"]) / 4);
        $frameColor["G"] = round(($leftColor["G"] + $rightColor["G"] + $topColor["G"] + $bottomColor["G"]) / 4);
        $frameColor["B"] = round(($leftColor["B"] + $rightColor["B"] + $topColor["B"] + $bottomColor["B"]) / 4);
        $res = imagecreatetruecolor($w, $h);
        $fillColor = imagecolorallocate($res, $frameColor["R"], $frameColor["G"], $frameColor["B"]);
        imagefill($res, 0, 0, $fillColor);
    }
    imagecopy($res, $img, floor(($wMargin) / 2), floor(($hMargin) / 2), 0, 0, $x, $y);
    return $res;
}

function createMerge($imgFile1, $imgFile2, $mergeFile) {
    global $h, $w, $quality;
    $merge = imagecreatetruecolor(2*$w, $h);
	$img1 = imagecreatefromjpeg($imgFile1);
    $img1 = imageCreateMargin($img1);
	$img2 = imagecreatefromjpeg($imgFile2);
    $img2 = imageCreateMargin($img2);
    $res = imagecopy($merge, $img1, 0, 0, 0, 0, $w, $h);
    $res = $res && imagecopy($merge, $img2, $w, 0, 0, 0, $w, $h);
    $res = $res && imagejpeg($merge, $mergeFile, $quality);
    return $res;
}
?>